Subject: Re: bug#18522: 24.4.50; mapcar is very slow

From: Eli Zaretskii <[email-masked]>
Date: Thu, 25 Feb 2016 20:25:27 +0200

> From: Peter Münster <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Thu, 25 Feb 2016 19:10:58 +0100
> 
> On Thu, Feb 25 2016, Eli Zaretskii wrote:
> 
> >  . gnus-buffers references killed buffers because Peter kills buffers
> >    behind Gnus back, instead of letting them be killed through
> >    gnus-kill-buffer, which would have removed them from gnus-buffers
> 
> This point is perhaps not 100% accurate. After 6h running, here some
> more details about the situation:
> 
> - length of all_buffers:         74
> - length of buffer-list:         45
> - length of killed-buffer-names: 28
> - length of gnus-buffers:        17
> 
> Content of killed-buffer-names:
> 
> Name                                            Details
> -----------------------------------------------------------------------------
> " *mm*"                                         ???
> " *mm*-292588"                                  ???
> " *mm*-331546"                                  ???
> " *mm*-391449"                                  ???
> " *mm*-531130"                                  ???
> " *mm*-59524"                                   ???
> " *mm*-705438"                                  ???
> " *mm*-971636"                                  ???
> " *nnmail message-id cache*"                    ???
> " *nnml overview inbox*"                        ???
> " *server news.gmane.org nntp  *nntpd**"        ???
> " *server news.gmane.org nntp  *nntpd**"        ???
> " *server news.povray.org nntp  *nntpd**"       ???
> " *server news.povray.org nntp  *nntpd**"       ???
> "*Backtrace*"                                   killed by me with kill-buffer
> "*Completions*"                                 killed by me with kill-buffer
> "*Completions*"                                 killed by me with kill-buffer
> "*Help*"                                        killed by me with kill-buffer
> "*Summary nndraft:drafts*"                      killed by gnus-summary-exit
> "*Summary nntp+news.gmane.org:gmane.comp.
>                      embedded.openwrt.user*"    killed by gnus-summary-exit
> "*sent mail to SAV*"                            killed by me with kill-buffer
> "*sent mail to XXX*"                            killed by me with kill-buffer
> "*sent mail to YYY*"                            killed by me with kill-buffer
> "*unsent wide reply to Eli Zaretskii*"          killed by me with kill-buffer
> "*unsent wide reply to SAV*"                    killed by me with kill-buffer
> "*unsent wide reply to ZZZ*"                    killed by me with kill-buffer
> "gnus-util.el"                                  killed by me with kill-buffer
> "jl-encrypt.el"                                 killed by me with kill-buffer
> 
> There are 6 "#<killed buffer>" in gnus-buffers. That means, that I
> should have killed the 6 buffers "*sent ..." and "*unsent ..." with
> gnus-kill-buffer. I'll do that in the future. But what about the other buffers?

The *mm*-NNN buffers sound like something related to Gnus mail, so I
defer to you and Lars for describing their life cycle.

Likewise with *nnmail...*" and *server news....* buffers.

(It's quite possible that these were also killed by you at some
inopportune moment, btw, and that's why they are still around.  Can
you describe in more detail how you kill buffers?  Or maybe try
running for a few days without killing buffers, except manually when
you are done with visiting some file, and see what winds up in the
list of killed buffers?)

*Completions*, *Help*, and *Backtrace* -- simply don't kill them, it's
useless.  They will pop up again soon enough.

In any case, the other 2 measures should fix the original problem.